#ifndef UpperTesterGn_LAYER_H
#define UpperTesterGn_LAYER_H

#include "t_layer.hh"
#include "UpperTesterGnCodec.hh"

namespace LibItsGeoNetworking__TestSystem {
  class UpperTesterPort;
}

namespace LibItsGeoNetworking__TypesAndValues {
  class UtGnInitialize;
  class UtGnChangePosition;
  class UtGnTrigger;
  class UtAutoInteropTrigger;
}

class UpperTesterGnLayer : public t_layer<LibItsGeoNetworking__TestSystem::UpperTesterPort> {
  params _params;
  UpperTesterGnCodec _codec;
  
public:
  UpperTesterGnLayer() : t_layer<LibItsGeoNetworking__TestSystem::UpperTesterPort>(), _params(), _codec() {};
  UpperTesterGnLayer(const std::string & p_type, const std::string & param);
  virtual ~UpperTesterGnLayer() {};

  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnInitialize& send_par, params& p_params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnChangePosition& send_par, params& p_params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtGnTrigger& send_par, params& p_params);
  void sendMsg(const LibItsGeoNetworking__TypesAndValues::UtAutoInteropTrigger& send_par, params& p_params);
  
  virtual void send_data(OCTETSTRING& data, params& p_params);
  virtual void receive_data(OCTETSTRING& data, params& info);
};

#endif
